package ${basePackage}.frame.schedule;

import org.springframework.scheduling.config.FixedDelayTask;
import org.springframework.scheduling.config.FixedRateTask;
import org.springframework.scheduling.config.Task;

public abstract class RunRepeatTask extends RunTask {

    public abstract void config(Config config);

    public class Config {
        int interval = 10 * 60 * 1000;
        int initialDelay = 0;
        boolean fix = false;
    }

    @Override
    public Task build() {
        Config config = new Config();
        config(config);

        if (config.fix) {
            return new FixedRateTask(this, config.interval, config.initialDelay);
        } else {
            return new FixedDelayTask(this, config.interval, config.initialDelay);
        }
    }
}
